local Gnoll = _G.Gnoll
local GL = Gnoll.Locale

local CacheList = { }
local itemList = {}
local eventFrame = CreateFrame("FRAME")
 
local function OnEvent(self, event, arg1, arg2)
	for i = 1, #CacheList do
		--Trenner
		if string.find(CacheList[i],"t###") ~= nil then
			local _, start = string.find(CacheList[i],"t###")
			local id = string.sub(CacheList[i], start+1)
			itemid = CacheList[i]
			itemList[i] = { CacheList[i], id }
			itemList[itemid] = i
		elseif string.find(CacheList[i],"d###") ~= nil then
			local _, start = string.find(CacheList[i],"d###")
			local id = string.sub(CacheList[i], start+1)
			itemid = CacheList[i]
			itemList[i] = { CacheList[i], id }
			itemList[itemid] = i
		elseif string.find(CacheList[i],"s###") ~= nil then
			local _, start = string.find(CacheList[i],"s###")
			local id = string.sub(CacheList[i], start+1)
			itemid = CacheList[i]
			itemList[i] = { CacheList[i], id }
			itemList[itemid] = i
		elseif string.find(CacheList[i],"x###") ~= nil then
			local _, start = string.find(CacheList[i],"x###")
			local id = string.sub(CacheList[i], start+1)
			itemid = CacheList[i]
			itemList[i] = { CacheList[i], id }
			itemList[itemid] = i
			
			
			
		else
			
			none, link = GetItemInfo(CacheList[i])
			itemid = CacheList[i]
			itemList[i] = { itemid, link, "", "", "" }
			itemList[itemid] = i
		end
	end
	self.OnUpdate(itemList)
end
eventFrame:SetScript("OnEvent", OnEvent)

local function curnumbertoname(arg)
	local curency = tonumber(arg)
	local name, icon, tmp
	if curency >= 10000 then
		icon = "|TInterface\\ICONS\\INV_Misc_QuestionMark:0|t"
		if curency == 10001 then 
			name = icon..GL["Apexis Shard"] --
		elseif curency == 10002 then 
			name = icon..GL["Apexis Crystal"] -- 823
		elseif curency == 10003 then 
			name = icon..GL["Glowcap"]
		elseif curency == 10004 then 
			name = icon..GL["Holy Dust"]
		elseif curency == 10005 then 
			name = icon..GL["Arcane Rune"]
		elseif curency == 10006 then 
			name = icon..GL["Restored Artifact"]
		elseif curency == 10007 then 
			name = icon..GL["Blackfang Claw"]
		elseif curency == 10008 then 
			name = icon..GL["Hunter's Seeking Crystal"]
		elseif curency == 10009 then 
			name = icon..GL["Mark of Honor"]
		elseif curency == 10010 then 
			name = icon..GL["Primordial Saronite"]
		elseif curency == 10011 then 
			name = icon..GL["Restored Artifact"]
		elseif curency == 10012 then 
			name = icon..GL["Kyparite"]
		elseif curency == 10013 then 
			name = icon..GL["Nat's Lucky Coin"]
		elseif curency == 10014 then 
			name = icon..GL["Tattered Historical Parchments"]
		elseif curency == 10015 then 
			name = icon..GL["Love Token"]
		elseif curency == 10016 then 
			name = icon..GL["Lovely Charm Bracelet"]
		elseif curency == 10017 then 
			name = icon..GL["Coin of Ancestry"]
		elseif curency == 10018 then 
			name = icon..GL["Noblegarden Chocolate"]
		elseif curency == 10019 then 
			name = icon..GL["Burning Blossom"]
		elseif curency == 10020 then 
			name = icon..GL["Brewfest Prize Token"]
		elseif curency == 10021 then 
			name = icon..GL["Tricky Treat"]
		elseif curency == 10022 then 
			name = icon..GL["Vicious Saddle"]
		elseif curency == 10023 then 
			name = icon..GL["Mark of Honor"]
		elseif curency == 10024 then 
			name = icon..GL["Drowned Mana"]
		end
		
		if strlen(name) > 75 then return strsub(name,0,75).."..." else return name end
	
	elseif curency == 0 then
		return "|TInterface\\MONEYFRAME\\UI-GoldIcon:0|t"
	else
		name, x, texture = GetCurrencyInfo(arg)
		tmp = "|T"..texture..":0|t "..name
		if strlen(tmp) > 75 then return strsub(tmp,0,75).."..." else return tmp end
	end

end

local function comma_value(amount)
	local formatted = amount
	while true do  
		formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
		if (k==0) then
			break
		end
	end
	return formatted
end

function GetItemCache(CacheList,UpFunc)
	itemList = {}
	eventFrame.OnUpdate = UpFunc
	eventFrame:RegisterEvent("GET_ITEM_INFO_RECEIVED")
	for i = 1, #CacheList do
		if type(CacheList[i]) == "table" then  -- item mit preisen oder upgrades
		
			if string.find(CacheList[i][1],"t###") ~= nil then
				local _, start = string.find(CacheList[i][1],"t###")
				local id = string.sub(CacheList[i][1], start+1)
				local preis,currency = nil
				itemid = CacheList[i][1]
				itemList[i] = { CacheList[i][1], id}
				itemList[itemid] = i
				
			elseif string.find(CacheList[i][1],"d###") ~= nil then
				local _, start = string.find(CacheList[i][1],"d###")
				local id = string.sub(CacheList[i][1], start+1)
				local preis,currency = nil
				itemid = CacheList[i][1]
				itemList[i] = { CacheList[i][1], id}
				itemList[itemid] = i
				
			elseif string.find(CacheList[i][1],"x###") ~= nil then
				local _, start = string.find(CacheList[i][1],"x###")
				local id = string.sub(CacheList[i][1], start+1)
				local preis,currency = nil
				itemid = CacheList[i][1]
				itemList[i] = { CacheList[i][1], id}
				itemList[itemid] = i
				
			elseif string.find(CacheList[i][1],"s###") ~= nil then
				local _, start = string.find(CacheList[i][1],"s###")
				local id = string.sub(CacheList[i][1], start+1)
				local preis,currency = nil
				itemid = CacheList[i][1]
				itemList[i] = { CacheList[i][1], id}
				itemList[itemid] = i

			elseif string.find(CacheList[i][2],"update") ~= nil then
				local _, start = string.find(CacheList[i][2],"update")
				local update = string.sub(CacheList[i][2], start+1)
				local none, link = GetItemInfo("item:"..CacheList[i][1].."::::::::::::"..update)
				itemid = CacheList[i][1]
				itemList[i] = { itemid, link, nil, "update" }
				itemList[itemid] = i
				
			else ---------currencys und zeugs umwandeln 
				if type(CacheList[i][2]) == "table" then -- doppelwährung :()
					preis = { comma_value(CacheList[i][2][1]), comma_value(CacheList[i][2][2]) }
					currency = { curnumbertoname(CacheList[i][3][1]), curnumbertoname(CacheList[i][3][2])}
				else
					preis = comma_value(CacheList[i][2]).." "..curnumbertoname(CacheList[i][3])
					currency = "solo"
				end
								
				local none, link = GetItemInfo(CacheList[i][1])
				itemid = CacheList[i][1]
				itemList[i] = { itemid, link, preis, currency }
				itemList[itemid] = i
			end
		
		else 
			--Trenner
			if string.find(CacheList[i],"t###") ~= nil then
				local _, start = string.find(CacheList[i],"t###")
				local id = string.sub(CacheList[i], start+1)
				itemid = CacheList[i]
				itemList[i] = { CacheList[i], id}
				itemList[itemid] = i
			elseif string.find(CacheList[i],"d###") ~= nil then
				local _, start = string.find(CacheList[i],"d###")
				local id = string.sub(CacheList[i], start+1)
				itemid = CacheList[i]
				itemList[i] = { CacheList[i], id}
				itemList[itemid] = i
			elseif string.find(CacheList[i],"x###") ~= nil then
				local _, start = string.find(CacheList[i],"x###")
				local id = string.sub(CacheList[i], start+1)
				itemid = CacheList[i]
				itemList[i] = { CacheList[i], id}
				itemList[itemid] = i
			elseif string.find(CacheList[i],"s###") ~= nil then
				local _, start = string.find(CacheList[i],"s###")
				local id = string.sub(CacheList[i], start+1)
				itemid = CacheList[i]
				itemList[i] = { CacheList[i], id}
				itemList[itemid] = i
			else
				none, link = GetItemInfo(CacheList[i])
				itemid = CacheList[i]
				itemList[i] = { itemid, link, "", "" }
				itemList[itemid] = i
			end
		end
	end
	UpFunc(itemList)
end

function ClearCache()
	eventFrame:UnregisterEvent("GET_ITEM_INFO_RECEIVED")
	eventFrame.OnUpdate = nil
	table.wipe(itemList)
	table.wipe(CacheList)
end