local Gnoll = _G.Gnoll
local GL = Gnoll.Locale
local GLW = Gnoll.WoWLocale

local function OnEnterButton(self,link)
		GameTooltip:SetOwner(self, "ANCHOR_NONE")
		GameTooltip:SetPoint("BOTTOM", self, "LEFT", 0, 5)
		if link ~= nil then
			GameTooltip:SetHyperlink(link)
		end
end

local function OnLeaveButton(self)
	GameTooltip:Hide()
end

local function OnEnterButtonIcon(self,arg1,arg2)
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("BOTTOM", self, "LEFT", 0, 5)
	if arg1 ~= nil then
		if arg2 == "solo" then -- einzell
			GameTooltip:SetText(arg1)
		elseif type(arg1) == "table" then -- Doppelwährung
			GameTooltip:SetText(arg1[1].." "..arg2[1].." & "..arg1[2].." "..arg2[2])
		end
	end		
end

local function OnClickWish(self,arg1,arg2)
	local wl = arg2[1]
	local itemTable = arg1
	 if type(Gnoll["DB"]["wunschliste"][wl][itemTable[1]]) ~= "table" then
	 	Gnoll["DB"]["wunschliste"][wl][itemTable[1]] = { itemTable[2], arg2[2], arg2[3],arg2[4],arg2[5] }
	     ChatFrame1:AddMessage("[Gnoll] "..itemTable[2].." "..GL["ItemWishlistADD"])
	 else
	     Gnoll["DB"]["wunschliste"][wl][itemTable[1]] = nil
	     ChatFrame1:AddMessage("[Gnoll] "..itemTable[2].." "..GL["ItemWishlistDEL"])
	 end
end

local function initializeWishDropDown(self, level, menuList)
   local info = UIDropDownMenu_CreateInfo()
   if level == 1 or menuList == nil then
	    for k,v in pairs(Gnoll["DB"]["wunschliste"]["names"]) do   
		  info.text = v
		  info.value = v
		  info.func = OnClickWish
		  info.menuList = "wl"..k
		  info.hasArrow = true
		  UIDropDownMenu_AddButton(info, level)
	    end
	elseif string.match(menuList,"wl%d") ~= nil then 	
		local tmp1 = tonumber(string.sub(menuList, 3))
		local infoTable = { tmp1, Gnoll["tmp"]["wish"][2][1], Gnoll["tmp"]["wish"][2][2], Gnoll["tmp"]["wish"][2][3], Gnoll["tmp"]["wish"][2][4], Gnoll["tmp"]["wish"][2][5] }
		local itemTable = Gnoll["tmp"]["wish"][1]
		if type(Gnoll["DB"]["wunschliste"][tmp1][itemTable[1]]) ~= "table" then
			info.text, info.value, info.func, info.arg1, info.arg2 = GL["Add"], 0, OnClickWish, itemTable, infoTable
	    else
	    	info.text, info.value, info.func, info.arg1, info.arg2 = GL["Remove"], 0, OnClickWish, itemTable, infoTable
	    end
	    UIDropDownMenu_AddButton(info,level)
	end		      
end

function CreateItemButtons(Frame)
	ItemButtons = { { } }
	for i=1, 30 do
		if i <= 10 then
			abstand = i*40
			spalte = 55
		elseif i >= 11 and i <= 20 then 
			 abstand = (i-10) *40
			 spalte = 250+55
		elseif i >= 21 and i <= 30 then
			 abstand = (i-20) *40
			 spalte = 500+55
		end
			
		ItemButtons[i] = CreateFrame("Button", nil, Frame)

		button = ItemButtons[i]
		button:SetPoint("Topleft", Frame, 0+spalte-32, 0-abstand)
		button:SetWidth(232)
		button:SetHeight(32)

		local fo = button:CreateFontString()
		fo:SetFont("Fonts/FRIZQT__.TTF",11)
		fo:SetPoint("LEFT", button, "LEFT", 34,8)
		button:SetFontString(fo)
		
		local ntex = button:CreateTexture()
		ntex:SetTexture("Interface/FrameGeneral/UI-Background-Marble")
		ntex:SetAlpha(0.8) 
		ntex:SetAllPoints()

		button:SetNormalTexture(ntex)
		button:SetScript("OnLeave", OnLeaveButton)
		button:Hide()
		button:RegisterForClicks("AnyDown")

		button.icon = CreateFrame("Button", nil, button)
		icon = button.icon
		icon:SetPoint("Left", button, 0, 0)
		icon:SetWidth(32)
		icon:SetHeight(32)
		icon:SetScript("OnLeave", OnLeaveButton)
		
		local itex = icon:CreateTexture()
		itex:SetTexture("Interface\ICONS\Ability_Creature_Cursed_03")
		itex:SetAllPoints()
		icon:SetNormalTexture(itex)
		icon:Show()
		
		local fo = icon:CreateFontString()
		fo:SetFont("Fonts/FRIZQT__.TTF",9)
		fo:SetPoint("LEFT", button, "LEFT", 34,-10)
		icon:SetFontString(fo)
		
		button.currency = CreateFrame("Button", nil, button)
		CurTex = button.currency
		CurTex:SetPoint("BOTTOM", button, 10, 0)
		CurTex:SetScript("OnLeave", OnLeaveButton)
		CurTex:SetWidth(200)
		CurTex:SetHeight(12)
		CurTex:Hide()
	end
end

function ClearItemButtons()
	for i=1,30 do
		ItemButtons[i]:Hide()
		ItemButtons[i]:SetScript("OnEnter",OnLeaveButton)
		ItemButtons[i].icon:SetScript("OnEnter",OnLeaveButton)
		ItemButtons[i].currency:SetScript("OnEnter",OnLeaveButton)
	end
end

function UpdateItems(itemTable,button,arg2)
	ItemSeiteRechts:Hide()
	ItemSeiteLinks:Hide()
	ClearItemButtons()
	local x = 0
	local seite = -1
	local maxsites = math.ceil(#itemTable / 30)

	if arg2 == nil then 
		seite = 1 
	else 
		if arg2 > maxsites then
			seite = maxsites
		elseif arg2 < 1 then
			seite = 1
		else
			seite = arg2 
		end
	end 
	local start = 30 * seite -29
	local ende = 30 * seite
		
	ItemPagetext:SetText(string.format("|cFFFFFFFF"..GL["Page %d of %d"], seite,maxsites))
	
	---Buttons mit Funktionen belegen
	ItemSeiteLinks:SetScript("OnMouseDown", function(self, button,arg1,arg2)
		UpdateItems(itemTable, button, seite -1)
	end)

	ItemSeiteRechts:SetScript("OnMouseDown", function(self, button,arg1,arg2)
		UpdateItems(itemTable, button, seite +1)
	end)
	
	--Button aus ein blenderei
	if ende >= #itemTable then ItemSeiteRechts:Hide() else ItemSeiteRechts:Show() end
	if seite > 1 then ItemSeiteLinks:Show() else ItemSeiteLinks:Hide() end
	if #itemTable < ende then ende = #itemTable end
	
	local buttonid = 1	
	for i = start, ende do
		ItemButtons[buttonid]:Show()
		if itemTable[i][2] == nil then   --- Item muss noch Gecached werden
			ItemButtons[buttonid]:SetText("Getting ItemInfo")
			ItemButtons[buttonid].icon:SetText("")
			ItemButtons[buttonid]:SetScript("OnEnter", function(self,arg1)	OnEnterButton(self)	end)
			ItemFrame:SetScript("OnMouseWheel", function(self, delta) end)	
	
		---Trenner
		elseif string.find(itemTable[i][1],"d###") ~= nil then
				ItemButtons[buttonid]:SetText(itemTable[i][2])
				ItemButtons[buttonid]:SetAlpha(1)
				ItemButtons[buttonid].icon:SetAlpha(0)
		elseif string.find(itemTable[i][1],"s###") ~= nil then
				tmp = tonumber(itemTable[i][2])
				ItemButtons[buttonid]:SetText(GLW["Difficulty"][tmp])
				ItemButtons[buttonid].icon:SetAlpha(0)
				ItemButtons[buttonid]:SetAlpha(1)
		elseif string.find(itemTable[i][1],"x###") ~= nil then
				tmp = tonumber(itemTable[i][2])
				ItemButtons[buttonid]:SetText(GLW["Specs"][tmp])
				ItemButtons[buttonid].icon:SetAlpha(0)
				ItemButtons[buttonid]:SetAlpha(1)
		elseif string.find(itemTable[i][1],"t###")  ~= nil then	--- Platzhalter
			if itemTable[i][2] == "" then
				ItemButtons[buttonid]:SetText("PlatzHalter")
				ItemButtons[buttonid]:SetAlpha(0)
			elseif strlen(itemTable[i][2]) == 1 then	--- Ruf
				tmp = tonumber(itemTable[i][2])
				ItemButtons[buttonid]:SetText(GLW["Ruf"][tmp])
				ItemButtons[buttonid].icon:SetText("")
				ItemButtons[buttonid]:SetAlpha(1)
				
			elseif strlen(itemTable[i][2]) == 2 then
				tmp = tonumber(itemTable[i][2])-30
				ItemButtons[buttonid]:SetText(GLW["Classes"][tmp])
				ItemButtons[buttonid]:SetAlpha(1)
			else
				ItemButtons[buttonid]:SetText(GL[itemTable[i][2]])	--- TrennerText
				ItemButtons[buttonid].icon:SetText("")
				ItemButtons[buttonid]:SetAlpha(1)
			end
			ItemButtons[buttonid].icon:SetAlpha(0)
			ItemButtons[buttonid].currency:Hide()
			ItemButtons[buttonid]:SetScript("OnEnter", function(self,arg1)	OnEnterButton(self)	end)
			ItemButtons[buttonid].icon:SetScript("OnEnter", function(self,arg1) OnEnterButton(self) end)
		
		else
			--Inhalt
			local _, _, Farbe = string.find(itemTable[i][2],"|?c?f?f?(%x*)")
			local _, _, ItemName = string.find(itemTable[i][2],"|?h?%[?([^%[%]]*)%]")
			if strlen(ItemName) > 30 then ItemName = strsub(ItemName,0,30).."..." end 
			ItemButtons[buttonid]:SetText("|cff"..Farbe..ItemName)
						
			---Design der Wärhung
			if itemTable[i][4] == "" then  -- rücken
				ItemButtons[buttonid].icon:SetText(itemTable[i][3])
				ItemButtons[buttonid].currency:Hide()
				
			elseif itemTable[i][4] == "solo" then -- einzell
				ItemButtons[buttonid].icon:SetText(itemTable[i][3])
				ItemButtons[buttonid].currency:Show()
				ItemButtons[buttonid].currency:SetScript("OnEnter", function(self,arg1)
					OnEnterButtonIcon(self,itemTable[i][3],"solo")
				end)
				
			elseif type(itemTable[i][3]) == "table" then -- Doppelwährung
				ItemButtons[buttonid].icon:SetText(itemTable[i][3][1].." "..itemTable[i][4][1].." & "..itemTable[i][3][2].." "..itemTable[i][4][2])
				ItemButtons[buttonid].currency:Show()
				ItemButtons[buttonid].currency:SetScript("OnEnter", function(self,arg1) OnEnterButtonIcon(self,itemTable[i][3],itemTable[i][4]) end)
				
			elseif itemTable[i][4] == "update" then -- updatebares item
				ItemButtons[buttonid].icon:SetText(itemTable[i][3])
				ItemButtons[buttonid].currency:Show()
				ItemButtons[buttonid].currency:SetScript("OnEnter", function(self,arg1) OnEnterButtonIcon(self,itemTable[i][3],"solo")	end)
			else
				ItemButtons[buttonid].icon:SetText(itemTable[i][3].." - "..itemTable[i][4]) -- noramles item
				ItemButtons[buttonid].currency:Hide()
			end
			
			------Tooltips			
			ItemButtons[buttonid]:SetScript("OnEnter", function(self,arg1)	OnEnterButton(self,itemTable[i][2]) end)
			ItemButtons[buttonid].icon:SetScript("OnEnter", function(self,arg1) OnEnterButton(self,itemTable[i][2]) end)
			
			--Buttongeklcike
			ItemButtons[buttonid]:SetScript("OnClick", function(self, button)
				if button == "LeftButton" then 
					if(IsShiftKeyDown()) then
						local e = DEFAULT_CHAT_FRAME.editBox
						ChatEdit_ActivateChat(e)
						local tmp = e:GetText()
						e:SetText(tmp .. itemTable[i][2])
					elseif(IsControlKeyDown()) then
						DressUpItemLink(itemTable[i][2])
					end

				elseif button == "RightButton" then
  					local kontinent = tonumber(Gnoll["tmp"]["DDMP"][2])
					local instanz  = tonumber(Gnoll["tmp"]["DDMP"][3])
					local boss  = tonumber(Gnoll["tmp"]["DDMP"][4])
			        local art = Gnoll["tmp"]["DDMP"][1]

					Gnoll["tmp"]["wish"] = { }
					Gnoll["tmp"]["wish"][1] = itemTable[i]
					Gnoll["tmp"]["wish"][2] = { art, kontinent,instanz,boss }
					UIDropDownMenu_Initialize(WishDropDown, initializeWishDropDown, "MENU")
					ToggleDropDownMenu(1, nil, WishDropDown, self, -20, 0)
			    end
			end)

			--Buttongeklcike für Icons
			ItemButtons[buttonid].icon:SetScript("OnClick", function(self, button)
				if button == "LeftButton" then 
					if(IsShiftKeyDown()) then
						local e = DEFAULT_CHAT_FRAME.editBox
						ChatEdit_ActivateChat(e)
						local tmp = e:GetText()
						e:SetText(tmp .. itemTable[i][2])
					elseif(IsControlKeyDown()) then
						DressUpItemLink(itemTable[i][2])
					end
				
				elseif button == "RightButton" then
  					local kontinent = tonumber(Gnoll["tmp"]["DDMP"][2])
					local instanz  = tonumber(Gnoll["tmp"]["DDMP"][3])
					local boss  = tonumber(Gnoll["tmp"]["DDMP"][4])
			        local art = Gnoll["tmp"]["DDMP"][1]
  
					Gnoll["tmp"]["wish"] = { }
					Gnoll["tmp"]["wish"][1] = itemTable[i]
					Gnoll["tmp"]["wish"][2] = { art,kontinent,instanz,boss }
					UIDropDownMenu_Initialize(WishDropDown, initializeWishDropDown, "MENU")
					ToggleDropDownMenu(1, nil, WishDropDown, self, -20, 0)
			    end
			end)
			
			------Icons
			texture = GetItemIcon(itemTable[i][1])
			ItemButtons[buttonid].icon:SetNormalTexture(texture)
			ItemButtons[buttonid].icon:SetAlpha(1)
			ItemButtons[buttonid]:SetAlpha(1)

			ItemFrame:SetScript("OnMouseWheel", function(self, delta)
				UpdateItems(itemTable, button, seite - delta)
			end)
		end
		buttonid = buttonid +1	
	end
end


