local Gnoll = _G.Gnoll
local GL = Gnoll.Locale

local frame = CreateFrame( "Frame", "Gnoll Options", UIParent );
frame.name = "Gnoll";
frame:Hide()

local uniquealyzer = 1;
local function createCheckbutton(parent, x_loc, y_loc, displayname)
	uniquealyzer = uniquealyzer + 1;
	local checkbutton = CreateFrame("CheckButton", "Gnoll_checkbutton_0" .. uniquealyzer, parent, "ChatConfigCheckButtonTemplate");
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc);
	getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);
	return checkbutton;
end

frame:SetScript("OnShow", function(frame)
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
    title:SetPoint("TOPLEFT", 16, -16)
    title:SetText("Gnoll")
    local subtitle = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
    subtitle:SetHeight(35)
    subtitle:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)
    subtitle:SetPoint("RIGHT", frame, -32, 0)
    subtitle:SetNonSpaceWrap(true)
    subtitle:SetJustifyH("LEFT")
    subtitle:SetJustifyV("TOP")
    subtitle:SetText(GL["Note"])
	
	local check_welcome = createCheckbutton(frame, 10, -60, GL["opt-Welcome"]);
	--check_welcome.tooltip = "";
	check_welcome:SetScript("OnClick", 
	function()
		  Gnoll.DB["opt"]["welcome"] = check_welcome:GetChecked()
	end);
	
	local check_minimaphide = createCheckbutton(frame, 10, -90, GL["opt-MHide"]);
	check_minimaphide:SetScript("OnClick", 
	function()
		Gnoll.DB["opt"]["minimap"]["hide"] = check_minimaphide:GetChecked()
	end);
	  
	local check_minimaplock = createCheckbutton(frame, 10, -120, GL["opt-MLock"]);
	check_minimaplock:SetScript("OnClick", 
	function()
	  Gnoll.DB["opt"]["minimap"]["lock"] = check_minimaplock:GetChecked()
	end);

	check_welcome:SetChecked(Gnoll.DB["opt"]["welcome"]);
	check_minimaphide:SetChecked(Gnoll.DB["opt"]["minimap"]["hide"]);
	check_minimaplock:SetChecked(Gnoll.DB["opt"]["minimap"]["lock"]);
	
	frame:SetScript("OnShow", nil)
end)

InterfaceOptions_AddCategory(frame)




